#! /bin/sh

# source the file that contains paths 
echo Set up env...
BASEDIR=$(dirname $0)
source  $(pwd)/$BASEDIR/env.sh
cd $ROOTPATH

# Create the all: rule for Makefile
echo Create main rule for Makefile..
MAKEFILE_ALL=
SIZE=$(wc -l $ROOTPATH/formula/data| awk '{print $1}')
for i in $(seq 1 "$SIZE"); do
    MAKEFILE_ALL="$MAKEFILE_ALL r$i.log"
done



echo "Create Makefile.. (it could take a while!)"
rm -f Makefile

cat > Makefile <<EOF
all: $MAKEFILE_ALL

EOF


for i in $(seq 1 "$SIZE"); do
    cat >> Makefile <<EOF

r$i.log:
	echo "#! /bin/bash" >  r$i.log-sh 
	awk -v q="'" -v tool=" $DVE2CHECK " -v algo="$ALGO" -v nth="$NUM_THREADS" 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; printf "models/"\$\$1"";print " -" algo""nth ; exit;  }' $ROOTPATH/formula/data  >> r$i.log-sh
	chmod a+x r$i.log-sh 
	bash ./r$i.log-sh > r$i.log-tmp
	mv r$i.log-tmp r$i.log
	rm r$i.log-sh
EOF
done

echo "" >> Makefile
for i in $(cat $ROOTPATH/formula/data | awk '{print $1}' | sort -u);do
    TMP=$(nl formula/data | grep "$i" | awk '{print $1}'  | sed -e 's/^/r/' -e 's/$/.log/' | tr "\n" " ")
    echo $i: $TMP >> Makefile
    echo "" >> Makefile
done


cat >> Makefile <<EOF

clean:
	rm -f *.log
cleanall:
	make clean
	rm -f *.cpp *.dve2C
EOF

#
# To avoid conflict when running make -j xx where xx is strictly greater than 1 
# Indeed in this case, two processes can try to regenerate the same Library and produce
# conflicts.
#
echo Generate shared Libraries !
for i in $(ls $ROOTPATH/models/*.dve); do 
    echo  '    ' For $(basename $i)
    $DVE2CHECK 'false' $i -concur_ec_dead_tarjan1 2>&1>&/tmp/null
done

exit 1

 
